(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-control")

(define (make-row cmd)
  (vector (woo-get-option cmd 'name)
          (woo-get-option cmd 'summary)))

(define (toggle-mode)
  (woo-catch/message
   (thunk
    (modes current (modes active))
    (woo-write (string-append "/control/" (facilities text))
               'current (modes text)))))

(groupbox (_ "Facilities")
          (document:id facilities
                       (listbox columns 2
                                header (vector (_ "Facility") (_ "Summary"))
                                rows (map make-row (woo-list "/control"))
                                (when selected
                                  (b activity #t)
                                  (let* ((path (string-append "/control/"
                                                              (facilities text)))
                                         (avail-modes (woo-list-names (string-append path "/avail")))
                                         (current-mode (woo-get-option
                                                        (woo-read-first path)
                                                        'current))
                                         (current-help (woo-get-option
                                                        (woo-read-first (string-append path
                                                                                       "/avail/"
                                                                                       current-mode))
                                                        'help)))
                                    (modes rows avail-modes)
                                    (modes current (string-list-index current-mode avail-modes))
                                    (mode-help text current-help)))
                                )))
(groupbox (_ "State")
          (hbox
           (vbox (document:id modes
                              (radiolist
                               (when selected
                                 (mode-help text (woo-get-option
                                                  (woo-read-first
                                                   (string-append "/control/"
                                                                  (facilities text)
                                                                  "/avail/"
                                                                  (modes text)))
                                                  'help)))))
                 (document:id b (button (_ "Change state")
                                        activity #f
                                        (when clicked (toggle-mode)))))
           (document:id mode-help
                        (textbox ""))))

(hbox (button (_ "Quit") (when clicked (document:end))))
